package me.km.blocks;

import me.km.fluids.BlockFluidBase;
import me.km.fluids.ModFluids;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.item.ItemBlock;
import net.minecraftforge.fluids.BlockFluidClassic;
import net.minecraftforge.fml.common.registry.GameRegistry;

public class ModBlocks 
{
    public static BlockBase copperOre;
    public static BlockBase copperBlock;
    
    public static BlockFluidClassic poison;
    
    public static void init() 
    {
        copperOre = register((BlockBase) new BlockBase(Material.ROCK, "copper_ore", "oreCopper").setHardness(3.0F).setResistance(5.0F));
        copperOre = register((BlockBase) new BlockBase(Material.IRON, "copper_block", "blockCopper").setHardness(4.0F).setResistance(10.0F));
    
        poison = register(new BlockFluidBase(ModFluids.poison, Material.WATER));
    }

    private static <T extends Block> T register(T block, ItemBlock itemBlock) 
    {
        GameRegistry.register(block);
        GameRegistry.register(itemBlock);
        if (block instanceof BlockBase) 
        {
            ((BlockBase) block).registerItemModel(itemBlock);
        }
        if (block instanceof BlockFluidBase) 
        {
            ((BlockFluidBase) block).registerBlockModel();
        }
        return block;
    }

    private static <T extends Block> T register(T block) 
    {
        ItemBlock itemBlock = new ItemBlock(block);
        itemBlock.setRegistryName(block.getRegistryName());
        return register(block, itemBlock);
    }
}
