package me.km.commands;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.nms.NmsUtilities;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.item.ItemStack;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;

public class CommandItemInfo extends ModuleCommand
{
    public CommandItemInfo(Module m) 
    {
        super("iteminfo", m);
        super.setDescription("Gibt Information über ein Item aus");
        super.setUsage("/iteminfo");
        super.setPermission(Permissions.ITEMINFO);
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        Module m = this.getModule();
        EntityPlayerMP p = (EntityPlayerMP) cs;
        ItemStack stack = p.getHeldItemMainhand();
        if(stack == null || stack == ItemStack.EMPTY)
        {
            m.send(cs, "Du musst ein Item in der Hand halten.");
            return true;
        }
        cs.sendMessage(new TextComponentString(GlobalText.Spacer()));
        m.send(cs, "DV: §6" + stack.getItemDamage());
        m.send(cs, "Meta: §6" + stack.getMetadata());
        m.send(cs, "Item: §6" + stack.getItem());
        NmsUtilities.sendCopyableText(p, NmsUtilities.getNbtString(stack).replace("\"", "'"));
        return true;
    }
}
